=== pkg/rpm/CMakeLists.txt ===
##
##  $Id$
## 
##  This file is part of Vidalia, and is subject to the license terms in the
##  LICENSE file, found in the top level directory of this distribution. If 
##  you did not receive the LICENSE file with this file, you may obtain it
##  from the Vidalia source package distributed by the Vidalia Project at
##  http://www.vidalia-project.net/. No part of Vidalia, including this file,
##  may be copied, modified, propagated, or distributed except according to
##  the terms described in the LICENSE file.
##

## RPM Spec File
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/vidalia.spec.in
  ${CMAKE_CURRENT_BINARY_DIR}/vidalia.spec
)
