=== debian/changelog ===
vidalia (0.2.12-2) unstable; urgency=low

  * The 'It-is-a-nice-day-for-barbacue' dupload.
  * Debconf kills Tor daemon while told not to (Closes: #623203).
  * Missing steps on CookieAuthentication/ControlPort documentation
    (Closes: #623309).

 -- Ulises Vitulli <dererk@debian.org>  Tue, 19 Apr 2011 12:26:26 -0300

vidalia (0.2.12-1) unstable; urgency=low

  * The 'Long-time-no-see!' dupload.
  * New upstream release.
  * Updated Homepage field.
  * Updated Standard-version to 3.9.2.0 (no changes needed).

 -- Ulises Vitulli <dererk@debian.org>  Mon, 11 Apr 2011 11:20:42 -0300
